<?php
namespace Teknisa\GQL\Modules\Atendimento\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\Report\ReportService;

class Gql01400EmissaoOcorrenciaAtendimentoController extends \Zeedhi\Framework\Controller\Report
{
    protected $qr2Strategy;
    protected $stNomeRel;
    protected $stExtensao;
    
    public function __construct(reportService $reportService, $qr2Strategy) 
    {
        parent::__construct($reportService);
        $this->qr2Strategy = $qr2Strategy;
    }
    
    protected $reportMapping = array ();
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] =
        array (
            'strategy' => $row["STRATEGY"],
            'parameterMapping' => 
            array (
                'DATAINI'       => 'P_DATAINI',
                'DATAFIN'       => 'P_DATAFIN',
                'STATUS'        => 'L_STATUS',
                'UNIDADE'       => 'L_CDFILIAL',
                'FORNECEDOR'    => 'L_CDFORNECED',
            ),
        );
    }
}