<?php
namespace Teknisa\GQL\Modules\Cadastros\Controllers;

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\GER\Services\CryptService;
use Teknisa\GQL\Modules\Cadastros\Services\Gql01800QualificacaoProdutoFornecedorService;

class Gql01800QualificacaoProdutoFornecedorController 
{
    public function __construct($service, CryptService $cryptService)
    {
        $this->service      = $service;
        $this->cryptService = $cryptService;
    }
    
    public function deleteQualificacaoProdutoFornecedor(DTO\Request $request, DTO\Response $response)
    {
		try {
            $row = $request->getRow();
            
			$this->service->deleteQualificacaoProdutoFornecedor($row);
			
			$response->addMessage(new Message("Alterado com sucesso."));
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}
	
	public function VerificaQualificacaoProdutoFornecedor(DTO\Request $request, DTO\Response $response)
	{
		$row = $request->getRow();
		$resultado = $this->service->getVerificaInserirAlterar($row);
		
		if (empty($resultado)) {
			$this->service->insertQualificacaoProdutoFornecedor($row);
		} else {
		 	$this->service->UpdateQualificacaoProdutoFornecedor($row);
		}
	}
	
	public function insertQualificacaoProdutoFornecedor(DTO\Request $request, DTO\Response $response)
	{
		try {
            $row = $request->getRow();
            
			$this->service->insertQualificacaoProdutoFornecedor($row);

			$response->addMessage(new Message("Salvo com sucesso."));
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}
	
	public function UpdateQualificacaoProdutoFornecedor(DTO\Request $request, DTO\Response $response)
	{
		try {
            $row = $request->getRow();
            
			$this->service->UpdateQualificacaoProdutoFornecedor($row);

			$response->addMessage(new Message("Salvo com sucesso."));
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}
	
	public function passwordValidation(DTO\Request $request, DTO\Response $response)
	{
		try {
            $row = $request->getRow();
            
            $operador = $this->service->selectOperador($row);
            $passwordEncrypted = $this->cryptService->getDelphiCrypt($row['PASSWORD']);
            
	        if ($passwordEncrypted != $operador[0]['CDSENHOPER']) {
	            throw new \Exception("Senha inválida", 1);
	        }
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}
}