<?php

namespace Teknisa\GQL\Modules\Cadastros\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class gql00200GrupoDeOcorrenciasService
{
    protected $connection;
    
    public function __construct($entityManager, $environment)
    {
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
    }
    
    /********************
     *      SELECTS     *
     * ******************/
    
    public function getGrupoOcorrencia ($row)
    {
        $params = [
            'P_CDGRPOCOR'  => $row['CDGRPOCOR'],
        ];
        
        $query = "SELECT
                       RETORNO
                    FROM
                       (SELECT COUNT(*) RETORNO
                        FROM
                           GRUPOCOR
                        WHERE
                           (CDGRPOCOR  = :P_CDGRPOCOR))";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
            return $std->fetchAll();
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    /********************
     *      UPDATES     *
     * ******************/
     
    public function updateGrupoOcorrencia ($row)
    {
        $params = [
            'P_CDGRPOCOR'   => $row['CDGRPOCOR'],
            'P_IDTIPGRP'    => $row['IDTIPGRP'],
            'P_DSGRPOCOR'   => $row['DSGRPOCOR'],
            'OLD_CDGRPOCOR' => $row['OLD_CDGRPOCOR'],
        ];
        
        $query = "UPDATE GRUPOCOR
                    SET
                      CDGRPOCOR = :P_CDGRPOCOR,
                      IDTIPGRP = :P_IDTIPGRP,
                      DSGRPOCOR = :P_DSGRPOCOR
                    WHERE
                      CDGRPOCOR = :OLD_CDGRPOCOR";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    /********************
     *      INSERTS     *
     * ******************/
     
    public function insertGrupoOcorrencia ($row)
    {
        $params = [
            'P_CDGRPOCOR'  => $row['CDGRPOCOR'],
            'P_IDTIPGRP'   => $row['IDTIPGRP'],
            'P_DSGRPOCOR'  => $row['DSGRPOCOR'],
            'P_NRORG'      => $this->environment->getNrorg(),
        ];
        
        $query = "INSERT INTO GRUPOCOR
                      (CDGRPOCOR, IDTIPGRP, DSGRPOCOR, NRORG)
                    VALUES
                      (:P_CDGRPOCOR, :P_IDTIPGRP, :P_DSGRPOCOR, :P_NRORG)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    /********************
     *      DELETES     *
     * ******************/
     
    public function deleteGrupoOcorrencia ($row)
    {
        $params = [
            'P_CDGRPOCOR'  => $row['CDGRPOCOR'],
        ];
        
        $query = "DELETE FROM GRUPOCOR
                    WHERE
                      CDGRPOCOR = :P_CDGRPOCOR";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
}